import { Path } from '../path';
import { State } from '../state';
import { FeatureBase, PartialToken, Token, TokenExtension } from '../token';
declare const _errorToken: unique symbol;
declare const _showAllErrors: unique symbol;
export interface ErrorMessages {
    [path: string]: string;
}
export interface ErrorMessage extends FeatureBase<'ErrorMessage', ErrorMessage> {
    payload: {
        readonly [_errorToken]: PartialToken<State<string, unknown>>;
        readonly [_showAllErrors]: PartialToken<State<boolean>>;
    };
    childFeatures: {
        [P in PropertyKey]: ErrorMessage;
    };
}
export interface ErrorOptions {
    errorsToken: Token<State<ErrorMessages, unknown>>;
    showAllErrorsToken: Token<State<boolean>>;
}
export declare function addErrorMessages(options: ErrorOptions): TokenExtension<Path, {
    add: ErrorMessage;
}>;
export declare function getTokenErrorMessage(token: PartialToken<ErrorMessage>): string | undefined;
export declare function getShowAllErrors(token: PartialToken<ErrorMessage>): boolean;
export declare function setShowAllErrors(token: PartialToken<ErrorMessage>, value: boolean): void;
export declare function useTokenErrorMessage(token: PartialToken<ErrorMessage> | undefined): string | undefined;
export {};
