import { AnySchema } from 'yup';
import { FeatureBase, NoFeature, PartialToken, TokenExtension } from '../token';
declare const _schema: unique symbol;
export interface Schema extends FeatureBase<'Schema', Schema> {
    payload: {
        readonly [_schema]: AnySchema;
    };
    childFeatures: {
        [P in PropertyKey]: Schema;
    };
}
export declare function addSchema(schema: AnySchema): TokenExtension<NoFeature, {
    add: Schema;
}>;
export declare function getTokenSchema(token: PartialToken<Schema>): AnySchema;
export interface SchemaInfo {
    label?: string;
    required?: boolean;
}
export declare function useTokenSchemaInfo(token: PartialToken<Schema> | undefined): SchemaInfo;
export {};
