import { Path } from '../path';
import { State } from '../state';
import { FeatureBase, PartialToken, Token, TokenExtension } from '../token';
declare const _touchedToken: unique symbol;
export interface TouchedFieldsState {
    [path: string]: boolean;
}
export interface TouchedInfo extends FeatureBase<'TouchedInfo', TouchedInfo> {
    payload: {
        readonly [_touchedToken]: PartialToken<State<boolean, unknown>>;
    };
    childFeatures: {
        [P in PropertyKey]: TouchedInfo;
    };
}
export interface TouchedOptions {
    touchedFieldsToken: Token<State<TouchedFieldsState, unknown>>;
}
export declare function addTouched(options: TouchedOptions): TokenExtension<Path, {
    add: TouchedInfo;
}>;
export declare function getTokenTouched(token: PartialToken<TouchedInfo>): boolean | undefined;
export declare function setTokenTouched(token: PartialToken<TouchedInfo>, touched: boolean): void;
export declare function useTokenTouched(token: PartialToken<TouchedInfo> | undefined): boolean;
export {};
